#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;

my %amino_acids = (
	Ala => 71,
	Arg => 156,
	Asn => 114,
	Asp => 115,
	Cys => 103,
	Gln => 128,
	Glu => 129,
	Gly => 57,
	His => 137,
	Ile => 113,
	Leu => 113,
	Lys => 128,
	Met => 131,
	Phe => 147,
	Pro => 97,
	Ser => 87,
	Thr => 101,
	Trp => 186,
	Tyr => 163,
	Val => 99,
);

if (exists $amino_acids{Trp}) {
	print "Tryptophan has a molecular weight of $amino_acids{Trp}\n";
}
else {
	print "My list was not aromatic enough.\n";
}

foreach my $aa (sort {$amino_acids{$b} <=> $amino_acids{$a}} keys %amino_acids) {
	print "$aa\t$amino_acids{$aa}\n";
}

my $lysozyme = 'MKALLTLGLLLLSVTAQAKVYNRCELARILKRNGMDGYRGVKLADWVCLAQHESNYNTRATNYNRGDRSTDYGIFQINSRYWCNDGKTPRSKNACGINCSALLQDDITAAIQCAKRVVRDPQGIRAWVAWRTQCQNRDLSQYIRNCGV';

my @letters = split(//,$lysozyme);

my $total_weight = 0;

my %single_to_triple_letters = (
	A => "Ala",
	R => "Arg",
	N => "Asn",
	D => "Asp",
	C => "Cys",
	Q => "Gln",
	E => "Glu",
	G => "Gly",
	H => "His",
	I => "Ile",
	L => "Leu",
	K => "Lys",
	M => "Met",
	F => "Phe",
	P => "Pro",
	S => "Ser",
	T => "Thr",
	W => "Trp",
	Y => "Tyr",
	V => "Val",
);

foreach my $letter (@letters) {
    $total_weight += $amino_acids{$single_to_triple_letters{$letter}}; 
}

print "The total weight of lysozyme is $total_weight\n";

