#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;


my @data;

# Generate a random data set of between 10 and 20
# measures, each of which is between 0 and 100
for (1..(10+int(rand(11)))){
	push @data, int(rand(101));
}

print "Data: ",join(" ",@data),"\n";
	
my ($mean,$var,$stdev) = calculate_stats(@data);
	
print "Mean:\t$mean\nVar:\t$var\nStdev:\t$stdev\n";
	



sub calculate_stats {

	my @values = @_;
	die "No data provided to calcualte statistics" unless (@values);
	
	my $total = 0;
	$total += $_ foreach (@values);
	
	my $mean = $total/@values;
	
	# Now calculate the variance
	my $var_total = 0;
	
	$var_total += (($_-$mean)**2) foreach (@values);
	my $variance = $var_total/$#values;
	
	return($mean,$variance,sqrt($variance));
	
}